## monado 0.1.0+git108.a8a4d8c3

=== CMakeLists.txt ===
# Copyright 2018-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

cmake_minimum_required(VERSION 3.13.0)
project(XRT VERSION 0.1.0)

# CMake 3.11 introduced CMP0072 - Prefer GLVND
if(POLICY CMP0072)
	cmake_policy(SET CMP0072 NEW)
endif()

option(OPENXR_USE_LOADER "Application uses loader" ON)
option(OPENXR_INSTALL_ABSOLUTE_RUNTIME_PATH "Use the absolute path to the runtime in the installed manifest, rather than a bare filename." ON)
option(VULKAN_ENABLE_VALIDATION "Enable Vulkan validation for Compositor" ON)
option(INSTALL_ACTIVE_RUNTIME "Make Monado the default OpenXR runtime on install" ON)

###
# Dependencies
###
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
include(CMakeDependentOption)
include(SPIR-V)
include(GNUInstallDirs)

find_package(Eigen3 REQUIRED)
find_package(Vulkan REQUIRED)
find_package(EGL)
find_package(HIDAPI)
find_package(OpenHMD)
find_package(OpenCV COMPONENTS core calib3d highgui imgproc imgcodecs features2d video)
find_package(Libusb1)
find_package(JPEG)
find_package(realsense2)
find_package(SDL2)
find_package(Threads)
find_package(ZLIB)

# @TODO Turn into a find_package LIBUVC file.
pkg_check_modules(LIBUVC libuvc)

# @TODO Turn into a find_package FFMPEG file.
pkg_check_modules(FFMPEG libavcodec)


if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	# Compositor backend
	find_package(X11)
	find_package(PkgConfig)

	find_package(udev REQUIRED)
	set(BUILD_DRIVER_V4L2 TRUE)
	if(PKGCONFIG_FOUND)
		pkg_check_modules(XCB xcb xcb-randr)

		pkg_search_module(WAYLAND wayland-client)
		pkg_search_module(WAYLAND_SCANNER wayland-scanner)
		pkg_search_module(WAYLAND_PROTOCOLS wayland-protocols)
	endif()
	find_package(OpenGL COMPONENTS GLX)
	pkg_search_module(DBUS dbus-1)

else()
	find_package(OpenGL)
endif()

cmake_dependent_option(BUILD_WITH_WAYLAND "Enable Wayland support" ON "WAYLAND_FOUND AND WAYLAND_SCANNER_FOUND AND WAYLAND_PROTOCOLS_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_XLIB "Enable xlib support" ON "X11_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_XCB "Enable xcb support" ON "XCB_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_OPENGL "Enable OpenGL Graphics API support" ON "OPENGL_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_EGL "Enable OpenGL on EGL Graphics API support" ON "BUILD_WITH_OPENGL AND EGL_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_DBUS "Enable dbus support (for BLE support)" ON "DBUS_FOUND" OFF)
cmake_dependent_option(BUILD_COMPOSITOR_MAIN "Build main compositor host" ON "BUILD_WITH_WAYLAND OR BUILD_WITH_XCB" OFF)
cmake_dependent_option(BUILD_TARGET_OPENXR "Build OpenXR runtime target" ON "BUILD_COMPOSITOR_MAIN" OFF)

# Most users won't touch these.
mark_as_advanced(BUILD_COMPOSITOR_MAIN BUILD_TARGET_OPENXR)

if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
	set(BUILD_WITH_LIBUDEV ON)
else()
	cmake_dependent_option(BUILD_WITH_LIBUDEV "Enable libudev (used for device probing on Linux)" ON "UDEV_FOUND" OFF)
endif()
cmake_dependent_option(BUILD_WITH_LIBUSB "Enable libusb (used for most drivers)" ON "LIBUSB1_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_JPEG "Enable jpeg code (used for some video drivers)" ON "JPEG_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_OPENCV "Enable OpenCV backend" ON "OpenCV_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_LIBUVC "Enable libuvc video driver" ON "LIBUVC_FOUND AND BUILD_WITH_LIBUSB" OFF)
cmake_dependent_option(BUILD_WITH_FFMPEG "Enable ffmpeg testing video driver" ON "FFMPEG_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_PSVR "Enable PSVR HMD driver" ON "HIDAPI_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_RS "Enable RealSense device driver" ON "realsense2_FOUND" OFF)
option(BUILD_WITH_DUMMY "Enable dummy driver" ON)
cmake_dependent_option(BUILD_WITH_VIVE "Enable Vive driver" ON "ZLIB_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_OPENHMD "Enable OpenHMD driver" ON "OPENHMD_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_SDL2 "Enable SDL2 based test application" ON "SDL2_FOUND" OFF)
cmake_dependent_option(BUILD_WITH_DAYDREAM "Enable Bluetooth LE via DBUS" ON "BUILD_WITH_DBUS" OFF)
cmake_dependent_option(BUILD_WITH_ARDUINO "Enable Arduino input device with BLE via DBUS" ON "BUILD_WITH_DBUS" OFF)

# These all use the Monado internal hid wrapper which is assumed to be available.
option(BUILD_WITH_HDK "Enable HDK driver" ON)
option(BUILD_WITH_PSMV "Enable Playstation Move driver" ON)
option(BUILD_WITH_HYDRA "Enable Hydra driver" ON)
option(BUILD_WITH_NS "Enable North Star driver" ON)

# You can set this from a superproject to add a driver
list(APPEND AVAILABLE_DRIVERS ARDUINO DUMMY HDK HYDRA NS OHMD PSMV PSVR RS V4L2 VIVE DAYDREAM)

###
# Flags
###

if(BUILD_WITH_LIBUDEV)
	set(XRT_HAVE_LIBUDEV TRUE)
endif()

if(BUILD_WITH_DBUS)
	set(XRT_HAVE_DBUS TRUE)
endif()

if(BUILD_DRIVER_V4L2)
	set(XRT_HAVE_V4L2 TRUE)
endif()

if(BUILD_WITH_LIBUSB)
	set(XRT_HAVE_LIBUSB TRUE)
endif()

if(BUILD_WITH_OPENCV)
	set(XRT_HAVE_OPENCV TRUE)

	# Tracking requires OpenCV
	set(BUILD_TRACKING TRUE)
endif()

if(BUILD_WITH_JPEG)
	set(XRT_HAVE_JPEG TRUE)
endif()

if(BUILD_WITH_LIBUVC)
	set(XRT_HAVE_LIBUVC TRUE)
endif()

if(BUILD_WITH_FFMPEG)
	set(XRT_HAVE_FFMPEG TRUE)
endif()

if(BUILD_WITH_SDL2)
	set(XRT_HAVE_SDL2 TRUE)

	# Arch work around
	if(NOT DEFINED SDL2_LIBRARIES)
		set(SDL2_LIBRARIES SDL2::SDL2)
	endif()

	# SDL2 based gui
	set(BUILD_TARGET_GUI TRUE)
endif()


if(BUILD_WITH_ARDUINO)
	set(BUILD_DRIVER_ARDUINO TRUE)
endif()

if(BUILD_WITH_DUMMY)
	set(BUILD_DRIVER_DUMMY TRUE)
endif()

if(BUILD_WITH_OPENHMD)
	set(XRT_HAVE_OPENHMD TRUE)

	# Drivers enabled with OpenHMD.
	set(BUILD_DRIVER_OHMD TRUE)
endif()

if(BUILD_WITH_NS)
	set(BUILD_DRIVER_NS TRUE)
endif()

if(BUILD_WITH_PSVR)
	if (NOT ${HIDAPI_FOUND})
		message(FATAL_ERROR "PSVR driver requires hidapi")
	endif()

	set(BUILD_DRIVER_PSVR TRUE)
endif()

if(BUILD_WITH_RS)
	if (NOT ${realsense2_FOUND})
		message(FATAL_ERROR "RealSense driver requires librealsense2")
	endif()

	set(BUILD_DRIVER_RS TRUE)
endif()

if(BUILD_WITH_VIVE)
	set(BUILD_DRIVER_VIVE TRUE)
endif()

if(BUILD_WITH_HDK)
	set(BUILD_DRIVER_HDK TRUE)
endif()

if(BUILD_WITH_PSMV)
	set(BUILD_DRIVER_PSMV TRUE)
endif()

if(BUILD_WITH_HYDRA)
	set(BUILD_DRIVER_HYDRA TRUE)
endif()

if(BUILD_WITH_DAYDREAM)
	set(BUILD_DRIVER_DAYDREAM TRUE)
endif()


# Vulkan flags for the shared Vulkan code.
if(BUILD_WITH_XCB)
	set(VK_USE_PLATFORM_XCB_KHR TRUE)
endif()
if(BUILD_WITH_XCB AND BUILD_WITH_XLIB)
	set(VK_USE_PLATFORM_XLIB_XRANDR_EXT TRUE)
endif()
if(BUILD_WITH_WAYLAND)
	set(VK_USE_PLATFORM_WAYLAND_KHR TRUE)
endif()


set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -pedantic -Wall -Wextra -Wno-unused-parameter")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter")

if(NOT MSVC)
	set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--no-undefined")
	set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,--no-undefined")
endif()

# Default to PIC code
set(CMAKE_POSITION_INDEPENDENT_CODE ON)


###
# Decend into madness.
###

add_subdirectory(src)
add_subdirectory(doc)

=== meson_options.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

option('drivers',
	type: 'array',
	choices: ['auto', 'dummy', 'hdk', 'hydra', 'ns', 'ohmd', 'psmv', 'psvr', 'rs', 'v4l2', 'vive'],
	value: ['auto'],
	description: 'Set of drivers to build')

option('docs',
	type: 'feature',
	value: 'auto',
	description: 'Build the documentation')

option('doxygen-warn-undocumented',
	type: 'boolean',
	value: false,
	description: 'Configure doxygen to emit warnings for undocumented entities')

option('doxygen-extract-all',
	type: 'boolean',
	value: false,
	description: 'Extract all entities for documentation, not just documented ones')

option('gui',
	type: 'feature',
	value: 'auto',
	description: 'Enable GUI')

option('tracking',
	type: 'feature',
	value: 'auto',
	description: 'Enable tracking support')

option('vulkan-validation',
	type: 'boolean',
	value: true,
	description: 'Enable Vulkan validation for compositor')

option('install-active-runtime',
	type: 'boolean',
	value: true,
	description: 'Make Monado the default OpenXR runtime on install')

option('opengl',
	type: 'feature',
	value: 'auto',
	description: 'Enable OpenGL/GLES application support.')

option('egl',
	type: 'feature',
	value: 'auto',
	description: 'Enable EGL application support.')

option('xlib',
	type: 'feature',
	value: 'auto',
	description: 'Enable xlib application support. Also required for direct mode on X.')

option('xcb',
	type: 'feature',
	value: 'auto',
	description: 'Enable xcb support for direct mode on X.')

option('wayland',
	type: 'feature',
	value: 'auto',
	description: 'Enable support for Wayland rendering.')

=== doc/CMakeLists.txt ===
# Copyright 2018-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

# check if Doxygen is installed
find_package(Doxygen)
cmake_dependent_option(BUILD_DOC "Build documentation" ON "DOXYGEN_FOUND" OFF)
cmake_dependent_option(BUILD_DOC_WARN_UNDOCUMENTED "Warn on undocumented entities when building documentation" OFF "DOXYGEN_FOUND" OFF)
cmake_dependent_option(BUILD_DOC_EXTRACT_ALL "Extract all entities for documentation, not just documented ones (conflicts with BUILD_DOCS_WARN_UNDOCUMENTED)" ON "DOXYGEN_FOUND; NOT BUILD_DOCS_WARN_UNDOCUMENTED" OFF)

if(BUILD_DOC)
    if(BUILD_DOC_WARN_UNDOCUMENTED)
        set(DOXYGEN_WARN_UNDOCUMENTED YES)
    else()
        set(DOXYGEN_WARN_UNDOCUMENTED NO)
    endif()
    if(BUILD_DOC_EXTRACT_ALL)
        set(DOXYGEN_EXTRACT_ALL YES)
    else()
        set(DOXYGEN_EXTRACT_ALL NO)
    endif()

    # set input and output files
    set(DOXYGEN_IN ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in)
    set(DOXYGEN_OUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)

    set(CURBUILDDIR ${CMAKE_CURRENT_BINARY_DIR})
    set(SRCDIR ${PROJECT_SOURCE_DIR})
    set(BUILDDIR ${PROJECT_BINARY_DIR})
    # request to configure the file
    configure_file(${DOXYGEN_IN} ${DOXYGEN_OUT} @ONLY)

    # note the option ALL which allows to build the docs together with the application
    add_custom_target(doc_doxygen ALL
        COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_OUT}
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating API documentation with Doxygen"
        VERBATIM
        )
endif()

=== src/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

# "Link" against this interface target if your module
# uses the files in "external".
add_library(xrt-external-headers INTERFACE)
target_include_directories(xrt-external-headers SYSTEM INTERFACE ${CMAKE_CURRENT_SOURCE_DIR}/external)

add_subdirectory(xrt)

=== src/xrt/CMakeLists.txt ===
# Copyright 2019, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

add_subdirectory(include)
add_subdirectory(auxiliary)
add_subdirectory(drivers)
add_subdirectory(compositor)
add_subdirectory(state_trackers)
add_subdirectory(targets)

=== src/xrt/auxiliary/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

set(MATH_SOURCE_FILES
	math/m_api.h
	math/m_base.cpp
	math/m_eigen_interop.hpp
	math/m_filter_fifo.c
	math/m_filter_fifo.h
	math/m_hash.cpp
	math/m_imu_3dof.c
	math/m_imu_3dof.h
	math/m_imu_pre.c
	math/m_imu_pre.h
	math/m_optics.c
	math/m_quatexpmap.cpp
	math/m_vec2.h
	math/m_vec3.h
	)

set(OGL_SOURCE_FILES
	ogl/ogl_api.c
	ogl/ogl_api.h
	ogl/ogl_documentation.h
	)

set(OS_SOURCE_FILES
	os/os_ble.h
	os/os_documentation.h
	os/os_hid.h
	os/os_hid_hidraw.c
	os/os_threading.h
	)
if(BUILD_WITH_DBUS)
	list(APPEND OS_SOURCE_FILES
		os/os_ble_dbus.c
		)
endif()

set(TRACKING_SOURCE_FILES
	tracking/t_data_utils.c
	tracking/t_imu_fusion.hpp
	tracking/t_imu.cpp
	tracking/t_imu.h
	tracking/t_lowpass_vector.hpp
	tracking/t_lowpass.hpp
	tracking/t_tracking.h
	)
if(BUILD_TRACKING)
	list(APPEND TRACKING_SOURCE_FILES
		tracking/t_calibration_opencv.hpp
		tracking/t_calibration.cpp
		tracking/t_convert.cpp
		tracking/t_debug_hsv_filter.cpp
		tracking/t_debug_hsv_picker.cpp
		tracking/t_debug_hsv_viewer.cpp
		tracking/t_file.cpp
		tracking/t_fusion.hpp
		tracking/t_helper_debug_sink.hpp
		tracking/t_hsv_filter.c
		tracking/t_kalman.cpp
		tracking/t_tracker_psmv_fusion.hpp
		tracking/t_tracker_psmv.cpp
		tracking/t_tracker_psvr.cpp
		)
endif()

set(UTIL_SOURCE_FILES
	util/u_bitwise.c
	util/u_bitwise.h
	util/u_misc.c
	util/u_misc.h
	util/u_debug.c
	util/u_debug.h
	util/u_device.c
	util/u_device.h
	util/u_distortion_mesh.c
	util/u_distortion_mesh.h
	util/u_documentation.h
	util/u_format.c
	util/u_format.h
	util/u_frame.c
	util/u_frame.h
	util/u_hashmap.cpp
	util/u_hashmap.h
	util/u_hashset.cpp
	util/u_hashset.h
	util/u_json.c
	util/u_json.h
	util/u_sink.h
	util/u_sink_converter.c
	util/u_sink_deinterleaver.c
	util/u_sink_queue.c
	util/u_sink_quirk.c
	util/u_sink_split.c
	util/u_time.cpp
	util/u_time.h
	util/u_var.cpp
	util/u_var.h
	)

set(VK_SOURCE_FILES
	vk/vk_helpers.c
	vk/vk_helpers.h
	vk/vk_documentation.h
	)

# Common includes
add_library(aux-includes INTERFACE)
target_include_directories(aux-includes INTERFACE ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(aux-includes INTERFACE xrt-interfaces)

# OpenGL library.
add_library(aux_ogl STATIC ${OGL_SOURCE_FILES})
target_link_libraries(aux_ogl PUBLIC aux-includes)
# for GLAD
target_link_libraries(aux_ogl PRIVATE xrt-external-headers)

# OS library.
add_library(aux_os STATIC ${OS_SOURCE_FILES})
target_link_libraries(aux_os PUBLIC aux-includes PRIVATE Threads::Threads)
if(BUILD_WITH_DBUS)
	target_link_libraries(aux_os PRIVATE ${DBUS_LIBRARIES})
	target_include_directories(aux_os SYSTEM
		PRIVATE
		${DBUS_INCLUDE_DIRS}
		)
endif()

# Math library.
add_library(aux_math STATIC ${MATH_SOURCE_FILES})
target_link_libraries(aux_math PUBLIC aux-includes)

# Math files has extra include(s).
target_include_directories(aux_math SYSTEM
	PRIVATE ${EIGEN3_INCLUDE_DIR}
	)

# Util library.
add_library(aux_util STATIC ${UTIL_SOURCE_FILES})
target_link_libraries(aux_util PUBLIC aux-includes)
# for cJSON
target_link_libraries(aux_util PUBLIC xrt-external-headers)
# for u_device
target_link_libraries(aux_util PUBLIC aux_math)
if(BUILD_WITH_JPEG)
	target_link_libraries(aux_util PRIVATE ${JPEG_LIBRARIES})
endif()

# Tracking library.
add_library(aux_tracking STATIC ${TRACKING_SOURCE_FILES})
target_link_libraries(aux_tracking PUBLIC aux-includes PRIVATE aux_math)

# Tracking files have extra includes.
target_include_directories(aux_tracking SYSTEM
	PRIVATE
	${EIGEN3_INCLUDE_DIR}
	)
# for flexkalman
target_link_libraries(aux_tracking PRIVATE xrt-external-headers)
if(BUILD_TRACKING)
	target_include_directories(aux_tracking SYSTEM
		PRIVATE
		${OpenCV_INCLUDE_DIRS}
		)
	target_link_libraries(aux_tracking PUBLIC ${OpenCV_LIBRARIES})
endif()

# Vulkan library.
add_library(aux_vk STATIC ${VK_SOURCE_FILES})
target_link_libraries(aux_vk PUBLIC aux-includes)
target_link_libraries(aux_vk PUBLIC Vulkan::Vulkan)

=== src/xrt/compositor/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

spirv_shaders(SHADER_HEADERS
	shaders/distortion.vert
	shaders/mesh.frag
	shaders/mesh.vert
	shaders/none.frag
	shaders/panotools.frag
	shaders/vive.frag
	)

set(CLIENT_SOURCE_FILES
	client/comp_vk_client.c
	client/comp_vk_client.h
	client/comp_vk_glue.c
	)

set(MAIN_SOURCE_FILES
	main/comp_compositor.c
	main/comp_compositor.h
	main/comp_distortion.c
	main/comp_distortion.h
	main/comp_documentation.h
	main/comp_renderer.c
	main/comp_renderer.h
	main/comp_settings.c
	main/comp_settings.h
	main/comp_swapchain.c
	main/comp_vk_swapchain.c
	main/comp_vk_swapchain.h
	main/comp_window.h
	)

if (VULKAN_ENABLE_VALIDATION)
	add_definitions(-DXRT_ENABLE_VK_VALIDATION)
endif()


###
# Client library
#

if(BUILD_WITH_OPENGL)
	list(APPEND CLIENT_SOURCE_FILES
		client/comp_gl_client.c
		client/comp_gl_client.h
		client/comp_gl_glue.c
		client/comp_gles_glue.c # TODO separate config for GLES
		)
endif()
if(BUILD_WITH_OPENGL AND BUILD_WITH_XLIB)
	list(APPEND CLIENT_SOURCE_FILES
		client/comp_gl_xlib_client.c
		client/comp_gl_xlib_client.h
		client/comp_gl_xlib_glue.c
		)
endif()
if(BUILD_WITH_OPENGL AND BUILD_WITH_EGL)
	list(APPEND CLIENT_SOURCE_FILES
		client/comp_egl_glue.c
		)
endif()

add_library(comp_client STATIC ${CLIENT_SOURCE_FILES})
target_link_libraries(comp_client PUBLIC xrt-interfaces PRIVATE aux_util aux_vk)
target_include_directories(comp_client PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})

if(BUILD_WITH_OPENGL)
	target_link_libraries(comp_client PRIVATE aux_ogl)
endif()

if(BUILD_WITH_OPENGL AND BUILD_WITH_XLIB)
	target_link_libraries(comp_client PRIVATE OpenGL::GLX)
endif()
##
# Main library
#

if(BUILD_COMPOSITOR_MAIN)

	if(BUILD_WITH_XCB)
		list(APPEND MAIN_SOURCE_FILES
			main/comp_window_xcb.cpp
			)
	endif()
	if(BUILD_WITH_XCB AND BUILD_WITH_XLIB)
		list(APPEND MAIN_SOURCE_FILES
			main/comp_window_direct_mode.cpp
			)
	endif()

	# generate wayland protocols
	if(BUILD_WITH_WAYLAND)
		pkg_get_variable(WL_PROTOS_PKG_DIR wayland-protocols pkgdatadir)
		pkg_get_variable(WL_SCANNER wayland-scanner wayland_scanner)

		set(WL_PROTOS_DIR "${CMAKE_CURRENT_BINARY_DIR}/wayland-protocols/")
		file(MAKE_DIRECTORY "${WL_PROTOS_DIR}")

		set(WL_PROTOS_XML "${WL_PROTOS_PKG_DIR}/stable/xdg-shell/xdg-shell.xml")
		set(WL_PROTOS_C "${WL_PROTOS_DIR}/xdg-shell.c")
		set(WL_PROTOS_H "${WL_PROTOS_DIR}/xdg-shell-client-protocol.h")

		add_custom_command(
			COMMAND
			${WL_SCANNER} private-code "${WL_PROTOS_XML}" "${WL_PROTOS_C}"
			OUTPUT "${WL_PROTOS_C}" VERBATIM)

		add_custom_command(
			COMMAND
			${WL_SCANNER} client-header "${WL_PROTOS_XML}" "${WL_PROTOS_H}"
			OUTPUT "${WL_PROTOS_H}" VERBATIM)

		set(WL_PROTOS_SRC ${WL_PROTOS_C} ${WL_PROTOS_H})
		list(APPEND MAIN_SOURCE_FILES
			main/comp_window_wayland.c
			)
	endif()

	add_library(comp_main STATIC ${SHADER_HEADERS} ${MAIN_SOURCE_FILES} ${WL_PROTOS_SRC})
	target_link_libraries(comp_main PUBLIC xrt-interfaces PRIVATE aux_util aux_os aux_vk)
	target_include_directories(comp_main PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
	target_include_directories(comp_main SYSTEM PRIVATE
		# Shaders - marked SYSTEM so we get no warnings
		${CMAKE_CURRENT_BINARY_DIR}
		)

	if(BUILD_WITH_WAYLAND)
		target_include_directories(comp_main SYSTEM PRIVATE ${WL_PROTOS_DIR})
		target_link_libraries(comp_main PRIVATE ${WAYLAND_LIBRARIES})
	endif()
	if(BUILD_WITH_XCB)
		target_include_directories(comp_main SYSTEM PRIVATE ${XCB_INCLUDE_DIRS})
		target_link_libraries(comp_main PRIVATE ${XCB_LIBRARIES})
	endif()

	if(BUILD_WITH_XCB AND BUILD_WITH_XLIB)
		target_link_libraries(comp_main PRIVATE ${X11_X11_LIB})
	endif()
	if(BUILD_WITH_EGL)
		target_include_directories(comp_main SYSTEM PRIVATE ${EGL_INCLUDE_DIRS})
		target_link_libraries(comp_main PRIVATE ${XCB_LIBRARIES})
	endif()

	add_subdirectory(shaders)
endif()

=== src/xrt/drivers/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0


set(ENABLED_HEADSET_DRIVERS)
set(ENABLED_DRIVERS)


if(BUILD_DRIVER_ARDUINO)
	set(ARDUINO_SOURCE_FILES
		arduino/arduino_device.c
		arduino/arduino_interface.h
		arduino/arduino_prober.c
		)

	add_library(drv_arduino STATIC ${ARDUINO_SOURCE_FILES})
	target_link_libraries(drv_arduino PRIVATE xrt-interfaces aux_util aux_os)
	list(APPEND ENABLED_DRIVERS arduino)
endif()

if(BUILD_DRIVER_DAYDREAM)
	set(DAYDREAM_SOURCE_FILES
		daydream/daydream_device.c
		daydream/daydream_device.h
		daydream/daydream_interface.h
		daydream/daydream_prober.c
		)

	add_library(drv_daydream STATIC ${DAYDREAM_SOURCE_FILES})
	target_link_libraries(drv_daydream PRIVATE xrt-interfaces aux_util aux_os)
	list(APPEND ENABLED_DRIVERS daydream)
endif()

if(BUILD_DRIVER_DUMMY)
	set(DUMMY_SOURCE_FILES
		dummy/dummy_hmd.c
		dummy/dummy_interface.h
		dummy/dummy_prober.c
		)

	add_library(drv_dummy STATIC ${DUMMY_SOURCE_FILES})
	target_link_libraries(drv_dummy PRIVATE xrt-interfaces aux_util)
	list(APPEND ENABLED_HEADSET_DRIVERS dummy)
endif()

if(BUILD_DRIVER_HDK)
	set(HDK_SOURCE_FILES
		hdk/hdk_device.cpp
		hdk/hdk_device.h
		hdk/hdk_interface.h
		hdk/hdk_prober.c
		)

	add_library(drv_hdk STATIC ${HDK_SOURCE_FILES})
	target_link_libraries(drv_hdk PRIVATE xrt-interfaces aux_math)
	list(APPEND ENABLED_HEADSET_DRIVERS hdk)
endif()


if(BUILD_DRIVER_HYDRA)
	set(HYDRA_SOURCE_FILES
		hydra/hydra_driver.c
		hydra/hydra_interface.h
		)

	add_library(drv_hydra STATIC ${HYDRA_SOURCE_FILES})
	target_link_libraries(drv_hydra PRIVATE xrt-interfaces aux_os)
	list(APPEND ENABLED_DRIVERS hydra)
endif()

if(BUILD_DRIVER_NS)
	set(NS_SOURCE_FILES
		north_star/distortion/utility_northstar.h
		north_star/distortion/deformation_northstar.h
		north_star/distortion/deformation_northstar.cpp
		north_star/ns_hmd.h
		north_star/ns_hmd.c
		north_star/ns_interface.h
		north_star/ns_prober.c
		)

	add_library(drv_ns STATIC ${NS_SOURCE_FILES})
	target_link_libraries(drv_ns PRIVATE xrt-interfaces aux_math xrt-external-headers)
	list(APPEND ENABLED_HEADSET_DRIVERS ns)
endif()

if(BUILD_DRIVER_OHMD)
	set(OHMD_SOURCE_FILES
		ohmd/oh_device.c
		ohmd/oh_device.h
		ohmd/oh_interface.h
		ohmd/oh_prober.c
		)

	add_library(drv_ohmd STATIC ${OHMD_SOURCE_FILES})
	target_link_libraries(drv_ohmd PRIVATE xrt-interfaces OpenHMD::OpenHMD aux_util aux_math)
	list(APPEND ENABLED_HEADSET_DRIVERS openhmd)
endif()


if(BUILD_DRIVER_PSMV)
	set(PSMOVE_SOURCE_FILES
		psmv/psmv_driver.c
		psmv/psmv_interface.h
		)

	add_library(drv_psmv STATIC ${PSMOVE_SOURCE_FILES})
	target_link_libraries(drv_psmv PRIVATE xrt-interfaces PUBLIC aux_os aux_tracking)
	list(APPEND ENABLED_DRIVERS psmv)
endif()

if(BUILD_DRIVER_PSVR)
	set(PSVR_SOURCE_FILES
		psvr/psvr_device.c
		psvr/psvr_device.h
		psvr/psvr_interface.h
		psvr/psvr_packet.c
		psvr/psvr_prober.c
		)

	add_library(drv_psvr STATIC ${PSVR_SOURCE_FILES})
	target_link_libraries(drv_psvr PRIVATE xrt-interfaces HIDAPI::hidapi aux_util)
	list(APPEND ENABLED_HEADSET_DRIVERS psvr)
endif()

if(BUILD_DRIVER_RS)
	set(RS_SOURCE_FILES
		realsense/rs_6dof.c
		)

	add_library(drv_rs STATIC ${RS_SOURCE_FILES})
	target_link_libraries(drv_rs PRIVATE xrt-interfaces realsense2::realsense2 aux_util)
	list(APPEND ENABLED_HEADSET_DRIVERS rs)
endif()

if(BUILD_DRIVER_VIVE)
	set(VIVE_SOURCE_FILES
		vive/vive_device.h
		vive/vive_device.c
		vive/vive_prober.h
		vive/vive_prober.c
		vive/vive_protocol.h
		)

	add_library(drv_vive STATIC ${VIVE_SOURCE_FILES})
	target_link_libraries(drv_vive PRIVATE xrt-interfaces aux_os aux_util aux_math)
	target_link_libraries(drv_vive PRIVATE ${ZLIB_LIBRARIES})
	target_include_directories(drv_vive PRIVATE ${ZLIB_INCLUDE_DIRS})
	list(APPEND ENABLED_HEADSET_DRIVERS vive)
endif()

if(BUILD_DRIVER_V4L2)
	set(V4L2_SOURCE_FILES
		v4l2/v4l2_driver.c
		)

	add_library(drv_v4l2 STATIC ${V4L2_SOURCE_FILES})
	target_link_libraries(drv_v4l2 PRIVATE xrt-interfaces aux_os)
	list(APPEND ENABLED_DRIVERS v4l2)
endif()

if(ENABLED_HEADSET_DRIVERS)
	set(ENABLED_DRIVERS ${ENABLED_HEADSET_DRIVERS} ${ENABLED_DRIVERS})
	list(SORT ENABLED_DRIVERS)
	string(REPLACE ";" " " ENABLED_DRIVERS "${ENABLED_DRIVERS}")
	message(STATUS "Enabled drivers: ${ENABLED_DRIVERS}")
else()
	message(FATAL_ERROR "You must enable at least one headset driver to build Monado.")
endif()

=== src/xrt/state_trackers/CMakeLists.txt ===
# Copyright 2019, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

add_subdirectory(gui)
add_subdirectory(oxr)
add_subdirectory(prober)

=== src/xrt/targets/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

######
# This is where we collect all of the pieces from the different parts of
# the source tree and build a complete driver or integration part.


add_subdirectory(common)

if(BUILD_TARGET_OPENXR)
	add_subdirectory(openxr)
endif()

add_subdirectory(cli)

if(BUILD_TARGET_GUI)
	add_subdirectory(gui)
endif()

=== src/xrt/include/xrt/CMakeLists.txt ===
# Copyright 2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

# Generate a header containing defines for each enabled driver
set(FILE_CONTENTS "")
foreach(DRIVER ${AVAILABLE_DRIVERS})
	if(BUILD_DRIVER_${DRIVER})
		string(APPEND FILE_CONTENTS "#define XRT_BUILD_DRIVER_${DRIVER}\n")
	endif()
endforeach()

# First setup all of the config headers.
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/xrt_config_drivers.h.cmake_in
	${CMAKE_CURRENT_BINARY_DIR}/xrt_config_drivers.h
	@ONLY
	)
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/xrt_config_have.h.cmake_in
	${CMAKE_CURRENT_BINARY_DIR}/xrt_config_have.h
	@ONLY
	)
configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/xrt_config_vulkan.h.cmake_in
	${CMAKE_CURRENT_BINARY_DIR}/xrt_config_vulkan.h
	@ONLY
	)

=== src/xrt/state_trackers/gui/CMakeLists.txt ===
# Copyright 2019-2020, Collabora, Ltd.
# SPDX-License-Identifier: BSL-1.0

set(GUI_SOURCE_FILES
	gui_common.h
	gui_imgui.h
	gui_ogl.c
	gui_prober.c
	gui_scene.cpp
	gui_scene_calibrate.c
	gui_scene_debug.c
	gui_scene_main_menu.c
	gui_scene_video.c
	../../../external/imgui/cimgui.cpp
	../../../external/imgui_monado/imgui_monado.cpp
	../../../external/imgui/cimgui.h
	../../../external/imgui/imconfig.h
	../../../external/imgui/imgui.cpp
	../../../external/imgui/imgui.h
	../../../external/imgui/imgui_demo.cpp
	../../../external/imgui/imgui_draw.cpp
	../../../external/imgui/imgui_impl_opengl3.cpp
	../../../external/imgui/imgui_impl_opengl3.h
	../../../external/imgui/imgui_internal.h
	../../../external/imgui/imgui_widgets.cpp
	../../../external/imgui/imstb_rectpack.h
	../../../external/imgui/imstb_textedit.h
	../../../external/imgui/imstb_truetype.h
	)

add_library(st_gui STATIC ${GUI_SOURCE_FILES})

target_link_libraries(st_gui PRIVATE aux_util xrt-external-headers)
target_include_directories(st_gui
	PUBLIC
	${CMAKE_CURRENT_SOURCE_DIR}/..
	)

if(BUILD_WITH_SDL2)
	add_library(imgui_impl_sdl STATIC 
		../../../external/imgui/cimgui_sdl.cpp
		../../../external/imgui/imgui_impl_sdl.cpp
		../../../external/imgui/imgui_impl_sdl.h
		)
	target_link_libraries(imgui_impl_sdl PRIVATE ${SDL2_LIBRARIES} xrt-external-headers)
	target_include_directories(imgui_impl_sdl PRIVATE ${SDL2_INCLUDE_DIRS})
endif()

=== debian/changelog ===
monado (0.1.0+git108.a8a4d8c3-2) unstable; urgency=medium

  * Add patches to fix build on ppc64el, s390x, powerpc
  * Rebuild to unblock migration.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Thu, 09 Apr 2020 18:03:59 -0500

monado (0.1.0+git108.a8a4d8c3-1) unstable; urgency=medium

  * Initial release (Closes: #943486)

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Wed, 08 Apr 2020 10:11:01 -0500

=== debian/control ===
Source: monado
Maintainer: Ryan Pavlik <ryan@ryanpavlik.com>
Uploaders: Andrew Lee (李健秋) <ajqlee@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               doxygen,
               glslang-tools,
               graphviz,
               libavcodec-dev,
               libcjson-dev,
               libegl1-mesa-dev,
               libeigen3-dev,
               libgl1-mesa-dev,
               libglvnd-dev,
               libhidapi-dev,
               libopencv-dev,
               libsdl2-dev,
               libudev-dev,
               libusb-1.0-0-dev,
               libuvc-dev,
               libv4l-dev,
               libvulkan-dev,
               libwayland-dev,
               libx11-dev,
               libxcb-randr0-dev,
               libxrandr-dev,
               libxxf86vm-dev,
               pkg-config
Standards-Version: 4.5.0
Vcs-Browser: https://gitlab.freedesktop.org/monado/monado
Vcs-Git: https://gitlab.freedesktop.org/monado/monado.git
Homepage: https://monado.freedesktop.org/
Rules-Requires-Root: no

Package: libopenxr1-monado
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: xr-hardware,
            libopenxr-loader1
Provides: libopenxr1
Description: Monado preview implementation of the OpenXR API
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides a runtime that aims to be a complete and conforming
 implementation of the OpenXR API from Khronos, after further development
 and once the conformance tests are released.

Package: monado-cli
Architecture: any
Section: graphics
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: xr-hardware
Description: Monado command-line utility
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides a command line utility that can be used to test
 probing for XR hardware.

Package: monado-gui
Architecture: any
Section: graphics
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: xr-hardware
Description: Monado GUI config and debug utility
 Monado is an open-source package for interacting with virtual and
 augmented reality (collectively known as XR) hardware and software.
 .
 This package provides a graphical interface utility that can be used to
 test probing for XR hardware, as well as performing calibration of
 cameras for use in tracking.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible+=fixfilepath

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

# We manage active runtime via update-alternatives
# We use a relative runtime path to allow Multi-Arch: same to work.
# TODO: use libcjson-dev instead of the vendored copy.
override_dh_auto_configure:
	dh_auto_configure -- -DINSTALL_ACTIVE_RUNTIME=OFF -DVULKAN_ENABLE_VALIDATION=OFF -DBUILD_DOC=OFF -DOPENXR_INSTALL_ABSOLUTE_RUNTIME_PATH=OFF

# Remove imgui config file if it's there.
override_dh_auto_clean:
	-rm -f imgui.ini
	dh_auto_clean

=== debian/tests/control ===
Tests: cli-probe, cli-test
Depends: monado-cli
Restrictions: superficial, allow-stderr
